struct SIO
{
	unsigned int	servo_buff[12], expose_time, log_thermo[300];
	unsigned int	log_datanum, log_time0, log_interval;
	unsigned char	command, run_mode;
	unsigned char	interval_mode, log_cds[300];
};


struct SWITCHES
{
	unsigned char	gyro_on, adxl_on;
};

struct SCAN
{
	unsigned char	mode, dir_head, dir_body, dir_v;
	unsigned char	scope;
	unsigned char	psd_data[91];
	unsigned char	sonic_data[91];
	unsigned char	cds_data[91];
};


/*********************************************************************************/
/*********************************************************************************/
/*********************************************************************************/
/*action1.c*/
unsigned char scan_PSD0(unsigned char mode, unsigned char raw_data[2][91], unsigned char dir_v);
unsigned char scan0(unsigned char mode, unsigned char psd_data[32], unsigned int sonic_data[32]);
unsigned char scan1(unsigned char psd_data[64], unsigned int sonic_data[64], unsigned char brightness[64]);
unsigned char scan2(struct SCAN *scan);

/*inits.c*/
void init_main(void);

/*sio2.c*/
char sio_comm1(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128]);
char sio_comm2(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128]);
char sio_comm3(struct SIO *sio, struct SWITCHES *switches
			   , unsigned int	mortion_arm[4096], unsigned int ptr_arm[128]);
void move_head(unsigned char dir_h, unsigned char dir_v, unsigned char dir_h2, unsigned char time);
void move_head2(unsigned char dir_h, unsigned char dir_v,  unsigned char dir_h2, unsigned char time);
void go(unsigned char dist_limit, unsigned char dist_limit_dir);
void stop(void);
void set_speed(unsigned char speed_R, unsigned char speed_L,
				unsigned char dirR, unsigned char dirL);

/*sio.c*/
void print_ii_sci0(unsigned int data);
void print_ii_sci1(unsigned int data);
void print_c_sci1(unsigned char	data);
void print_ii_sci1b(unsigned int data);
void print_c_sci2b(unsigned char data);
void print_c_sci1b(unsigned char data);
void print_c_sci0(unsigned char	data);
void print_s_sci1(char string[80]);
unsigned char read_c_sci1(void);
unsigned char read_c_sci0(void);
unsigned char read_c_sci1b(void);
unsigned char read_c_sci0b(void);
unsigned int  read_i_sci1(void);
unsigned int  read_ii_sci0(void);
unsigned int  read_ii_sci1(void);
unsigned int read_ii_sci1b(void);

/*inits.c*/
void init_main(void);

/*utility.c*/
unsigned char read_cds(void);
unsigned int read_sonic2(void);
float raw2cm_PSD(unsigned char raw_data);
float raw2mm_PSD(unsigned char raw_data);
void wait_touch(void);
unsigned char read_PSD3(void);
void read_PSD3b(unsigned char *raw_data, float *cm_data);
void read_PSD2(float data[2]);
void read_PSD(unsigned char data[4]);
unsigned char read_compass(void);
unsigned int read_add_clock(void);
void set_add_clock(unsigned char mode);
unsigned char check_status_servo(void);
void wait_servo(void);
void check_status_go(unsigned char status[2]);
void beep(unsigned char time, unsigned char tone, unsigned char num);
unsigned int read_therm(void);

/*wait_val.c*/
void wait(unsigned int time);
void wait0(void);
void wait_sec(unsigned int time);
void half_clock(void);

/*cam0.c*/
void get_gbimage1(unsigned char image_128[2][128][128], unsigned char image_8[8][8]);
unsigned char get_gbimage2(unsigned char image[2][128][128], unsigned char mode);
void adj_expose4(unsigned int expose_time);
unsigned char adj_expose3(unsigned int *expose_time1);
unsigned char adj_expose2(unsigned char image_data[2][128][128], unsigned int *expose_time1);
unsigned char adj_expose(unsigned char av_levelc, unsigned char mode, unsigned int *expose_time);
void set_register(unsigned char address, unsigned char data);
void reset_gb(void);
void start_gb(void);
unsigned char get_imgdatR(void);
unsigned char get_imgdatL(void);
void gb_init(void);

/*sonic0.c*/
